.\" .ER
.TH "RNAmultiloop" "1" "June 4 2010"
.SH "NAME"
RNAmultiloop \- calculate partition function of an RNA sequence with respect to the multiloop number/order K.
.SH "SYNOPSIS"
\fBRNAmultiloop \-s \fISEQUENCE\fP \-number|\-order [\-n \fINUM\fP]
.SH "DESCRIPTION"
.I RNAmultiloop
calculates the number of secondary structures, Boltzman probabilities and partition function of an RNA sequence with respect to the multiloop number/order K.
.SH "OPTIONS"
No dangles. Allow lonely base pairs.
.IP \fB\-s\fB
\fISEQUENCE\fP is the input RNA sequence.
.IP \fB\-number\fB
Do the multiloop number recursion. The results would be secondary structures, Boltzman probabilities and partition function of an RNA sequence with respect to the multiloop number K.
.IP \fB\-order\fB
Do the multiloop order recursion. The results would be secondary structures, Boltzman probabilities and partition function of an RNA sequence with respect to the multiloop order K.
.IP \fB\-n\fB
\fINUM\fP is the maximum number/order of the multiloop that one considers. The default value is 5.
.SH "REFERENCES"
If you use this program in your work you might want to cite:
.PP
Yang Ding, W. Andy Lorenz, Peter Clote(2010) Parametric Partition Function of RNA, In preparation.
.SH "VERSION"
This man page documents version 1.0 of RNAmultiloop program.
.SH "AUTHOR"
Yang Ding, W. Andy Lorenz, Peter Clote.
.SH "BUGS"
If you find any bugs, please send the report to clote@bc.edu. Any comments for improvement are welcome too.
.br
